"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const src_1 = tslib_1.__importDefault(require("../src"));
const axios_1 = tslib_1.__importDefault(require("axios"));
const index_config_1 = require("./utils/index.config");
// test('My Microservice', () => {
//     expect.assertions(1)
//     return expect(ms.start()).resolves.toBeTruthy()
// })
// test('Test route creation', () => {
//     expect.assertions(1)
//     return expect(axios.get('http://localhost:4010/test')).resolves.toBeTruthy()
// })
// const redisCon = {port: 6379, host: 'test', options: {password: 'test'}}
// const rabbitCon = {port: 15672, host: 'test', options: {password: 'test'}}
// // Create MS with rabbit, CRDB, and Redis
describe('Microservice Test Suite', () => {
    let ms;
    beforeAll(() => {
        //create MS and a route
        ms = new src_1.default(index_config_1.msTestConfig);
    });
    afterAll(() => {
        // Do Cleanup here
    });
    // MICROSERVICE CREATION
    describe('Microservice Operations', () => {
        test('Microservice Start', () => {
            expect.assertions(1);
            return expect(ms.start()).resolves.toBeTruthy();
        });
        test('Microservice Endpoint Creation', () => {
            expect.assertions(1);
            ms.declareRoute('GET', '/test', (req, res) => {
                res.send({ hi: 'there' });
            });
            return expect(axios_1.default.get('http://localhost:4010/test')).resolves.toBeTruthy();
        });
    });
    // DATABASE OPERATIONS
    describe('CRDB Operations', () => {
        // CREATE
        test('Create model', () => {
            // expect.assertions(1)
            // const response = ms.db.create(testUserMode, createUserData)
            // expect(response).toBe(something)
        });
        // UPDATE
        test('Update Model', () => {
            // expect.assertions(1)
            // const response = ms.db.update(testUserMode, updateUserData)
            // expect(response).toBe(something)
        });
        // FIND ALL
        test('Find All Models', () => {
            // expect.assertions(1)
            // const response = ms.db.findall(testUserMode)
            // expect(response).toBe(something)
        });
        // ADD
        test('Add Models', () => {
            // expect.assertions(1)
            // const response = ms.db.add(testUserMode)
            // expect(response).toBe(something)
        });
    });
    // REDIS OPERATIONS
    describe('Redis Operations', () => {
        // SET
        test('Set Key Value', () => {
            // expect.assertions(1)
            // const response = ms.redis.set(key, data, , 'error')
            // expect(response).toBe(something)
        });
        // SET IF EXIST
        test('Setnx: Key Exists', () => {
            // expect.assertions(1)
            // const response = ms.redis.setnx(key, data)
            // expect(response).toBe(something)
        });
        // SET IF NOT EXIST
        test('Setnx: Key Not Exists', () => {
            // expect.assertions(1)
            // const response = ms.db.update(key, data)
            // expect(response).toBe(something)
        });
        // GET
        test('Get Key', () => {
            // expect.assertions(1)
            // const response = ms.db.findall(key)
            // expect(response).toBe(something)
        });
    });
    // RABBIT OPERATIONS
    describe('Rabbit Operations', () => {
        const queue = 'testSuiteQueue';
        const exchange = 'testSuiteExcahnge';
        // GET STATUS
        test('Get Status', () => {
            // expect.assertions(1)
            // const response = ms.rabbit.getStatus()
            // expect(response).toBe("CONNECTED")
        });
        // CREATE EXCHANGE
        test('Create Exchange', () => {
            // expect.assertions(1)
            // const response = ms.rabbit.createExchange(exchange, "direct")
            // expect(response).toBe(somethign)
        });
        // CREATE QUEUE
        test('Create Queue', () => {
            // expect.assertions(1)
            // const response = ms.rabbit.createQueue(queue)
            // expect(response).toBe(somethign)
        });
        // BIND EXCHANGE TO QUEUE
        test('Bind Exchange to a Queue', () => {
            // expect.assertions(1)
            // const response = ms.rabbit.bindQueue(queue, exchange)
            // expect(response).toBe(somethign)
        });
        // PUBLISH QUEUE
        test('Publish Queue', () => {
            // expect.assertions(1)
            // const response = ms.rabbit.pub(queue, message)
            // expect(response).toBe(somethign)
        });
        // GET QUEUE
        test('Get Queue', () => {
            // expect.assertions(1)
            // const response = ms.rabbit.getMessageQueue(queue, message)
            // expect(response).toBe(somethign)
        });
        // SUBSCRIBE TO QUEUE
        test('Subscribe to Queue', () => {
            // expect.assertions(1)
            // const response = ms.rabbit.sub(queue, callback)
            // expect(response).toBe(somethign)
        });
        // DELETE QUEUE
        test('Delete Queue', () => {
            // expect.assertions(1)
            // const response = ms.rabbit.deleteQueue(queue)
            // expect(response).toBe(somethign)
        });
        // DELETE EXCHANGE
        test('Delete Exchange', () => {
            // expect.assertions(1)
            // const response = ms.rabbit.deleteExchange(exchange)
            // expect(response).toBe(somethign)
        });
    });
});
