import { Config } from './interfaces/config';
import redis from './utils/redis';
import * as Fastify from 'fastify';
import { Verbs } from './interfaces/common';
import rabbit from './utils/rabbit';
import logger from './utils/logger';
export default class Microservice {
    server: Fastify.FastifyInstance;
    private config;
    private agent;
    databases?: any;
    redis?: redis;
    rabbit?: rabbit;
    logger: logger;
    constructor(config: Config);
    declareRoute(verb: Verbs, path: string, handler: Fastify.RouteHandlerMethod, options?: Fastify.RouteOptions): void;
    publish(msg: string, queue: string): void;
    log(log: string): void;
    error(log: string, error?: number): void;
    start(): Promise<boolean>;
}
