import { exchanges, RabbbitStatus, IRabbitMSG } from '../interfaces/common';
export default class rabbit {
    /**
     * The RabbitMQ Class
     * @param STATUS - the status of rabbit connection
     * @param connection - connection to rabbit
     * @param connectionPromise - initiates connection to rabbit
     * @param messageStore - cached messages if connection lost to rabbit
     * @param logger - logger instance
     */
    private STATUS;
    private connection;
    private connectionPromise;
    private messageStore;
    private logger;
    constructor(url: string);
    private connector;
    private sendMessageQueue;
    getStatus(): RabbbitStatus;
    getMessageStore(): IRabbitMSG[];
    pub(Queue: string, Msg: string): Promise<void>;
    sub(Queue: string, callback: (msg: string) => void): Promise<void>;
    createQueue(queue: string): Promise<void>;
    deleteQueue(queue: string): Promise<void>;
    createExchange(name: string, type: exchanges): Promise<void>;
    deleteExchange(name: string): Promise<void>;
    bindQueue(
    /**
     * binds an exchange to a queue
     *
     * @param queueName - name of the queue
     * @param exchangeName - name of the exchange
     * @param pattern - ???
     * @param args - additional args
     *
     */
    queueName: string, exchangeName: string, pattern?: string, args?: any): void;
}
